// package com.jnssd.config;
//
// import io.swagger.v3.oas.models.tags.Tag;
// import org.springdoc.core.GroupedOpenApi;
// import org.springdoc.core.customizers.OpenApiCustomiser;
// import org.springdoc.core.customizers.OperationCustomizer;
// import org.springdoc.core.customizers.RouterOperationCustomizer;
// import org.springdoc.core.filters.OpenApiMethodFilter;
// import org.springframework.context.annotation.Bean;
// import org.springframework.context.annotation.Configuration;
// import org.springframework.http.HttpMethod;
//
// @Configuration
// public class SpringDocOpenApiConfig {
//
//
//     @Bean
//     public GroupedOpenApi publicApi() {
//         return GroupedOpenApi.builder()
//                 .group("menu")
//                 .pathsToMatch("/menu/**")
//                 .addOperationCustomizer(customizePublicApiOperations())
//                 .addOpenApiCustomiser(customizePublicApiOpenApi())
//                 .addRouterOperationCustomizer(customizePublicApiRouterOperations())
//                 .addOpenApiMethodFilter(publicApiMethodFilter())
//                 .build();
//     }
//
//     @Bean
//     public GroupedOpenApi privateApi() {
//         return GroupedOpenApi.builder()
//                 .group("user")
//                 .pathsToMatch("/user/**")
//                 .addOperationCustomizer(customizePrivateApiOperations())
//                 .addOpenApiCustomiser(customizePrivateApiOpenApi())
//                 .addRouterOperationCustomizer(customizePrivateApiRouterOperations())
//                 .addOpenApiMethodFilter(privateApiMethodFilter())
//                 .build();
//     }
//
//     // Customizing public API operations
//     private OperationCustomizer customizePublicApiOperations() {
//         return (operation, handlerMethod) -> {
//             // Customize the operations for the public API
//             operation.operationId("publicOperation");
//             operation.addTagsItem("Public API");
//             return operation;
//         };
//     }
//
//     // Customizing public API OpenAPI document
//     private OpenApiCustomiser customizePublicApiOpenApi() {
//         return (openApi) -> {
//             // Customize the OpenAPI document for the public API
//             openApi.addTagsItem(new Tag().name("Public API").description("Endpoints for public API"));
//         };
//     }
//
//     // Customizing public API router operations
//     private RouterOperationCustomizer customizePublicApiRouterOperations() {
//         return (routerOperation, handlerMethod) -> {
//             // Customize the router operations for the public API
//             // Customize the router operation as needed
//             return routerOperation;
//         };
//     }
//
//     // Filtering public API methods
//     private OpenApiMethodFilter publicApiMethodFilter() {
//         return (method) -> {
//             // Filter out DELETE methods from the public API
//             return HttpMethod.GET.matches(method.getName());
//             // return true;
//         };
//     }
//
//     // Customizing private API operations
//     private OperationCustomizer customizePrivateApiOperations() {
//         return (operation, handlerMethod) -> {
//             // Customize the operations for the private API
//             operation.operationId("privateOperation");
//             operation.addTagsItem("Private API");
//             return operation;
//         };
//     }
//
//     // Customizing private API OpenAPI document
//     private OpenApiCustomiser customizePrivateApiOpenApi() {
//         return (openApi) -> {
//             // Customize the OpenAPI document for the private API
//             openApi.addTagsItem(new Tag().name("Private API").description("Endpoints for private API"));
//         };
//     }
//
//     // Customizing private API router operations
//     private RouterOperationCustomizer customizePrivateApiRouterOperations() {
//         return (routerOperation, handlerMethod) -> {
//             // Customize the router operations for the private API
//             // Customize the router operation as needed
//             return routerOperation;
//         };
//     }
//
//     // Filtering private API methods
//     private OpenApiMethodFilter privateApiMethodFilter() {
//         return (method) -> {
//             // Filter out PATCH methods from the private API
//             return true;
//         };
//     }
// }
//
